package dalhelper

import (
	"sync"

	"corelab.mkcl.org/MKCLOS/coredevelopmentplatform/coreospackage/confighelper"

	"github.com/gocraft/dbr"
)

// Hold a single global connection (pooling provided by sql driver)
var sqlConnection *dbr.Connection
var connectionError error
var sqlOnce sync.Once

//GetSQLConnection to db
func GetSQLConnection() (*dbr.Connection, error) {
	sqlOnce.Do(func() {
		// create a connection db(e.g. "postgres", "mysql", or "sqlite3")
		connection, err := dbr.Open("mysql", confighelper.GetConfig("MysqlDSN"), nil)
		if err != nil {
			connectionError = err
		}
		//	connection.SetMaxIdleConns(10)
		//	connection.SetMaxOpenConns(5)
		sqlConnection = connection
	})
	return sqlConnection, connectionError
}
