package dalhelper

import (
	"sync"

	"corelab.mkcl.org/MKCLOS/coredevelopmentplatform/coreospackage/confighelper"

	mgo "gopkg.in/mgo.v2"
)

var instance *mgo.Session
var sessionError error
var once sync.Once

//GetMongoConnection method
func GetMongoConnection() (*mgo.Session, error) {
	once.Do(func() {
		Host := []string{
			confighelper.GetConfig("MONGODSN"),
		}
		var (
			Username = ""
			Password = ""
			Database = confighelper.GetConfig("DBNAME")
		)

		session, err := mgo.DialWithInfo(&mgo.DialInfo{
			Addrs:    Host,
			Username: Username,
			Password: Password,
			Database: Database,
		})
		if err != nil {
			sessionError = err
		}
		//defer session.Close()

		instance = session

	})
	return instance, sessionError
}
